\documentclass[tikz]{standalone}

\begin{document}
        \begin{tikzpicture}[scale=0.4]
            \draw[black,thick,->] (-4,0) -- (4,0) node[above] {$x$};
            \draw[black,thick,->] (0,-4) -- (0,4) node[right] {$g(x)$};
            \draw[black,dashed] (-4,-4) -- (4,4);
            \draw[black,dashed] (-4,4) -- (4,-4);
            
            \filldraw[black] (-1,-2) circle (3pt); % 1
            \draw[red,->] (-1,-2) -- (-2,-2) -- (-2,-4);
            
            \filldraw[black] (-2,-1) circle (3pt); % 2
            \draw[red,->] (-2,-1) -- (-1,-1) -- (-1,-0.5);
            
            \filldraw[black] (-2,1) circle (3pt); % 3
            \draw[red,->] (-2,1) -- (1,1) -- (1,-0.5);
            
            \filldraw[black] (-1,2) circle (3pt); % 4
            \draw[red,->] (-1,2) -- (2,2) -- (2,-4);
            
            \draw (-1,-3) node {1};
            \draw (-3,-1.5) node {2};
            \draw (-3,1.5) node {3};
            \draw (-1,3) node {4};
            \draw(1,3) node {1};
            \draw (3,1.5) node {2};
            \draw (3,-1.5) node {3};
            \draw (1,-3) node {4};
        \end{tikzpicture}
\end{document}